<template>
  <v-container>
    <v-btn @click="connect">
      {{ connectButton.text }}
    </v-btn>

    <registration />
    <governance />
    <delegator />
    <proposal />
    <mine-n-blocks />
  </v-container>
</template>

<script>
  import Governance from "../components/Governance";
  import Registration from "../components/Registration";
  import Delegator from "../components/Delegator";
  import Proposal from "../components/Proposal";
  import MineNBlocks from "../components/MineNBlocks";
  import { ethers } from "ethers";

  export default {
    name: 'Home',
    data: () => ({
      ethereum: null,
      connectButton: {
        text: "Connect"
      }
    }),
    components: {
      Registration,
      Delegator,
      Proposal,
      Governance,
      MineNBlocks
    },
    mounted() {
      this.ethereum = window.ethereum;

      this.$store.commit("setProvider", new ethers.providers.Web3Provider(this.ethereum));

      if (this.$store.state.accounts.length > 0) {
        this.connect();
      }

      this.ethereum.on('accountsChanged', (accounts) => {
        this.$store.state.accounts = accounts;
        this.connectButton.text = this.$store.state.accounts[0];
      });
    },
    methods: {
      async connect() {
        this.$store.commit("setAccounts", await window.ethereum.request({ method: "eth_requestAccounts" }));
        this.connectButton.text = this.$store.state.accounts[0];
      }
    }
  }
</script>
